SystemOrganization addCategory: #GhostProxiesTests!

TestCase subclass: #SimpleForwarderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests'!

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 16:38'!
testSimpleForwardingForClasses
    | aProxy aUser |
       aUser := User named: 'Kurt'.
       
	[aProxy := ClassProxy createProxyAndReplace: User. 
	Transcript show: aProxy name; cr.
       self assert: (User named: 'John') username equals: 'John'. 
    self assert: aUser username equals: 'Kurt'.
	] ensure: [ aProxy uninstall ]! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 13:25'!
testSimpleForwardingForMethod
       | aProxy aUser method |
       aUser := User named: 'Kurt'.
       method := User methodDict at: #username.
       aProxy := ObjectProxy proxyFor: method. 
       [User methodDict at: #username put: aProxy.
       self assert: aProxy getSource equals: 'username ^ username'. 
       self assert: aUser username equals: 'Kurt'.
	 ] ensure: [ User methodDict at: #username put: method. ]! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 10:57'!
testSimpleForwardingForRegularObject
	| proxy |
	proxy := ObjectProxy proxyFor: (Point x: 3 y: 4). 
	self assert: proxy x equals: 3. 
	self assert: proxy y equals: 4.! !
